/**
 * @class Sb.GoogleJsApi
 * @singleton
 */
Ext.define('Sb.GoogleJsApi', {
	singleton: true,
	isLoadingMaps: false,
	isLoadedMaps: false,
	loadCallbacks: {
		maps: []
	},

	/**
	 * @param {Function} callback
	 * @param {Object} [scope]
	 */
	loadMaps: function (callback, scope) {
		scope = scope || window;
		callback = Ext.createDelegate(callback, scope);

		if (this.isLoadedMaps) {
			callback();
			return;
		}

		this.loadCallbacks.maps.push(callback);
		if (this.isLoadingMaps) {
			return;
		}

		this.isLoadingMaps = true;
		Sb.ResourceManager.require([{url: '//www.google.com/jsapi', type: 'js'}], function () {
			google.load('maps', '3', {
				other_params: 'sensor=false&language=' + Sb.Editor.siteView.getCurrentSiteLocale() + (Sb.Config.googleMapApiKey != '' ? '&key=' + Sb.Config.googleMapApiKey : ''),
				callback: Ext.createDelegate(function () {
					Ext.each(this.loadCallbacks.maps, function (callback) {
						callback();
					});
					this.isLoadedMaps = true;
					this.isLoadingMaps = false;
					this.loadCallbacks.maps = [];
				}, this)
			});
		}, this);
	}
});