/**
 * @class Sb.dashboard.tile.EcwidTile
 * @extends Sb.dashboard.Tile
 * Class for ecwid tile
 * @xtype sb.dashboard.tile.ecwid
 */
Ext.define('Sb.dashboard.tile.EcwidTile', {
	extend: 'Sb.dashboard.Tile',
	xtype: 'sb.dashboard.tile.ecwid',

	initComponent: function () {
		this.model = this.manager.getModel('ecwid');
		this.mon(this.model, 'datachanged', this.dataChangeHandler, this);
		this.mon(this.model, 'error', this.errorHandler, this);

		Ext.apply(this, {
			titleString: Sb.Locale.get('orders'),
			logoCls: 'sb-dashboard-logo-orders'
		});

		Sb.dashboard.tile.EcwidTile.superclass.initComponent.call(this);

		this.showMessage(Sb.Locale.get('eshopLoadOrders'));
	},

	dataChangeHandler: function () {
		var el = this.getContentEl();

		if (!el.rendered) {
			return;
		}

		el.removeAll();
		el.add({
			xtype: 'box',
			html: Sb.Locale.get('eshopCountOrders', this.model.data.total) +
					' <a href="#">' + Sb.Locale.get('seeThemHere') + '</a>.'
		});
		el.doLayout();
		el.getEl().child('a').on('click', function () {
			var dashboard = Sb.Editor.windowManager.getManager(9).get('dashboardWindow'),
				notifyTab = dashboard.tabs.notificationTab;
			dashboard.tabs.setActiveTab(notifyTab);
			notifyTab.getComponent(0).setActiveTab(1);
		});
	}

});