/**
 * Edit flash dialog for text widget
 *
 * @class Sb.editor.FlashEditDialog
 * @extends Sb.editor.ImageEditDialog
 */
Ext.define('Sb.editor.FlashEditDialog', {
	extend: 'Sb.editor.ImageEditDialog',

	uploadUrl: Sb.Config.baseUrl + '/Upload/Flash/',
	title: Sb.Locale.get('flashEditDialogEdit'),
	hiddenAltText: true,
	flashPreview: null,
	flashVarsField: null,
	editDialogChange: Sb.Locale.get('flashEditDialogChange'),
	editDialogChangeWarningInvalidType: Sb.Locale.get('flashEditDialogChangeWarningInvalidType'),
	uploadingImage: Sb.Locale.get('uploadingFlash'),
	editDialogVarsTextLabel: Sb.Locale.get('flashEditDialogVarsTextLabel'),
	uploadValidRegex: new RegExp('\\.(' + Sb.Config.flashValidExtensions.join('|') + ')$', 'i'),

	constructor: function (config) {
		this.flashVarsField = new Ext.form.TextField({
			fieldLabel: this.editDialogVarsTextLabel,
			anchor: '100%'
		});

		config = Ext.apply({
			modelClass: Sb.auxilaryModel.Flash,
			rightColumnItems: [
				this.flashVarsField
			]
		}, config);

		Sb.editor.FlashEditDialog.superclass.constructor.call(this, config);
	},

	createPreview: function () {
		return new Ext.BoxComponent({
			autoEl: {
				tag: 'div',
				style: 'position: relative;'
			}
		});
	},

	updatePreview: function (src) {
		if (null !== this.flashPreview) {
			this.flashPreview.remove();
		}
		this.flashPreview = this.previewImg.el.createChild({
			html: Sb.utils.Flash.createCode(src, 200, 100)
		});
	},

	fillDialogFromModel: function () {
		this.flashVarsField.setRawValue(this.model.getFlashVars());
		Sb.editor.FlashEditDialog.superclass.fillDialogFromModel.call(this);
	},

	okHandler: function () {
		this.model.setFlashVars(this.flashVarsField.getValue());
		Sb.editor.FlashEditDialog.superclass.okHandler.call(this);
	}
});
