/**
 * @class Sb.form.FontSizeComboBox
 * @extends Ext.form.ComboBox
 * Control for selecting font size
 * @constructor
 * Create a new FontSizeComboBox.
 * @param {Object} config Configuration options
 * @xtype sbfontsizecombo
 */
Ext.define('Sb.form.FontSizeComboBox', {
	extend: 'Ext.form.ComboBox',
	xtype: 'sbfontsizecombo',

	store: new Ext.data.ArrayStore({
		fields: ['value'],
		data: [
			['8'], ['9'], ['10'], ['11'], ['12'], ['14'], ['16'], ['18'],
			['20'], ['22'], ['24'], ['26'], ['28'], ['36'], ['48'], ['72']
		]
	}),
	triggerAction: 'all',
	mode: 'local',
	valueField: 'value',
	displayField: 'value',
	focusAfterSelectEvent: true,
	editable: true,
	maskRe: /[0-9]/,
	fieldLabel: Sb.Locale.get('fontSize')
});