/**
 * @class Sb.form.PixelField
 * @extends Ext.form.SpinnerField
 * Class for pixel field
 * @constructor
 * @param {Object} config The config object
 * @xtype pixelfield
 */
Ext.define('Sb.form.PixelField', {
	extend: 'Ext.ux.form.SpinnerField',
	xtype: 'pixelfield',

	allowDecimals: false,
	allowBlank: false,
	minValue: 0,
	enableKeyEvents: true,

	listeners : {
		keydown: function () {
			this.oldValue = this.getValue();
		},

		keyup: function () {
			this.fireEvent('change', this, this.getValue(), this.oldValue);
		}
	},

	setValue: function (value) {
		var val = String(value).replace('px', '');
		return Sb.form.PixelField.superclass.setValue.call(this, val);
	},

	getValue: function () {
		var value = Sb.form.PixelField.superclass.getValue.call(this);
		return value ? value + 'px' : value;
	}
});