/**
 * @class Sb.form.ShadowSelectBox
 * @extends Sb.form.SelectBox
 */
Ext.define('Sb.form.ShadowSelectBox', {
	extend: 'Sb.form.SelectBox',
	xtype: 'sbshadowselectbox',

	width: 120,
	cls: 'sb-selectbox sb-shadows-selectbox',
	listClass: 'sb-selectbox-list sb-shadows-selectbox-list',
	lazyInit: false,
	triggerAction: 'all',
	header: {
		xtype: 'box',
		height: 38
	},
	lastQuery: '',
	valueField: 'value',
	triggerClass: 'sb-folder-trigger-small',
	itemRenderer: function (item) {
		return item.name === 'none'
			? '<span class="sb-no-shadow-title">' + Sb.Locale.get('noShadowTitle') + '</span>'
			: '<img class="sb-shadow-preview" src="' + Sb.Config.templatesUrl
				+ '/generic/decorations/shadows/' + item.name + '.png" />';
	},

	initComponent: function () {
		var store = Ext.StoreMgr.get('shadows');

		if (!store) {
			store = new Ext.data.JsonStore({
				storeId: 'shadows',
				fields: ['name', 'value'],
				autoLoad: true,
				url: Sb.Utils.antiCache(Sb.Config.templatesUrl + '/generic/decorations/shadows/list.json')
			});
		}

		this.store = store;

		Sb.form.ShadowSelectBox.superclass.initComponent.call(this);
	}
});