/**
 * @class Sb.model.CommentingWidget
 * @extends Sb.model.Widget
 * @constructor
 * @param {Object} config The configuration options for the widget model
 */
Ext.define('Sb.model.CommentingWidget', {
	extend: 'Sb.model.Widget',

	constructor: function (config) {
		config = Ext.apply({
			type: 'commenting'
		}, config);

		Sb.model.CommentingWidget.superclass.constructor.call(this, config);
		Sb.Editor.model.on('propertychange', function (key) {
			if (key === 'disqusId') {
				this.updateIsConfiguredProperties();
			}
		}, this);
		this.updateIsConfiguredProperties();
	},

	generateThreadId: function () {
		return Sb.Editor.model.get('uuid') + this.ownerPage.get('identity');
	},

	getUrl: function () {
		return this.ownerPage.getFullUrl();
	},

	getTitle: function () {
		return this.ownerPage.get('title');
	},

	computeIsConfiguredProperties: function () {
		return typeof Sb.Editor.model.get('disqusId') === 'string';
	}
});