/**
 * Allows to edit Language widget.
 *
 * @class Sb.widget.LanguageEditPanel
 * @extends Sb.widget.WidgetEditPanel
 */
Ext.define('Sb.widget.LanguageEditPanel', {
	extend: 'Sb.widget.WidgetEditPanel',

	initComponent: function () {
		this.appearances = new Ext.data.ArrayStore({
			fields: ['appearance'],
			data: [['combo'], ['advanced-combo'], ['icons'], ['large-icons']]
		});
		this.appearanceDataView = new Ext.DataView({
			singleSelect: true,
			cls: 'sb-widget-language-images-list',
			overClass: 'x-view-over',
			itemSelector: 'div.sb-selectbox-list-item',
			store: this.appearances,
			tpl: '<tpl for=".">' +
						'<div class="sb-selectbox-list-item"><div>' +
							'<img src="' + Sb.Config.baseUrl + '/widgets/language/skins/default/images/appearance-' +
								'{appearance}' + '.png" widht="195" height="54">' +
						'</div></div>' +
					'</tpl>',
			listeners: {
				scope: this,
				selectionchange: function (dataView) {
					var appearances = dataView.getSelectedRecords();
					if (!appearances.length) {
						return;
					}
					var value = appearances[0].get('appearance');
					this.widget.model.set('appearance', value);
				}
			}
		});

		Ext.apply(this, {
			layout		: 'form',
			labelAlign	: 'top',
			autoHeight	: true,
			cls			: 'sb-widget-edit-panel-language',
			items		: [{
					xtype: 'label',
					text: Sb.WidgetTypeManager.get('Language').getTranslation('appearanceFieldLabel')
				}, this.appearanceDataView
			]
		});

		Sb.widget.LanguageEditPanel.superclass.initComponent.apply(this, arguments);
	},

	show: function (widget) {
		Sb.widget.LanguageEditPanel.superclass.show.call(this, widget);

		this.appearanceDataView.select(
			this.appearances.findExact('appearance', widget.model.get('appearance'))
		);
	}
});
