/**
 * @class Sb.widget.Script
 * @extends Sb.widget.Widget
 * Class for global Script widget
 * @xtype script_widget
 *
 * :INFO: "code" property in model is not exist for new widgets
 */
Ext.define('Sb.widget.Script', {
	extend: 'Sb.widget.Widget',
	xtype: 'script_widget',
	cls: 'sb-widget-script',

	renderContent: function () {
		Sb.widget.Script.superclass.renderPlaceholder.call(this, this.getType().getTranslation('activeText'), false);
	},

	onCompleteEdit: function () {
		this.model.unserialize({'code': this.getType().getEditPanel().codeTextArea.getValue()});
		Sb.widget.Script.superclass.onCompleteEdit.apply(this, arguments);
		this.refreshContent();
	}
});