/**
 * @class Sb.widgetType.Blog
 * @extends Sb.widgetType.Base
 */
Ext.define('Sb.widgetType.Blog', {
	extend: 'Sb.widgetType.Base',

	onCacheChange: function () {
		Sb.widgetType.Blog.superclass.onCacheChange.call(this);

		var eshopWidgetType = Sb.WidgetTypeManager.get('EshopCatalog');
		eshopWidgetType.toggle(eshopWidgetType.isAvailable());
	},

	isDroppableTo: function (container) {
		return !container.isInSiteWideArea() &&
			container.get('type') === 'container_vertical' &&
			container.get('region') === 'content';
	},

	isAvailable: function () {
		var masterWidget;

		this.disableReason = '';

		if (!Sb.Editor.siteView.currentPage) {
			return true;
		}

		masterWidget = Sb.Editor.siteView.currentPage.getMasterWidget();
		if (masterWidget) {
			this.disableReason = masterWidget.getType().name;
			return false;
		}

		Sb.Editor.siteView.currentPage.pages.each(function(page) {
			if (!(page.getMasterWidget() instanceof Sb.model.BlogPostWidget)) {
				this.disableReason = 'subpages';
				return false;
			}
		}, this);

		return this.disableReason === '';
	}
});
