/**
 * @class Sb.widgetType.Commenting
 * @extends Sb.widgetType.Base
 */
Ext.define('Sb.widgetType.Commenting', {
	extend: 'Sb.widgetType.Base',

	allowedColors: '',

	isDroppableTo: function (container) {
		return !container.isInSiteWideArea() &&
			container.get('type') == 'container_vertical' &&
			container.get('region') == 'content';
	},

	isAvailable: function () {
		this.disableReason = '';

		if (Sb.Editor.isDemoMode()) {
			this.disableReason = 'demo';
			return false;
		}

		if (!Sb.Editor.siteView.currentPage) {
			return true;
		}

		if (Sb.Editor.siteView.currentPage.isPageHasCommenting()) {
			return false;
		}

		return true;
	}
});