Ext.isIE11 = !!window.navigator.userAgent.match(/Trident.*rv[ :]*11\./);
if (!Ext.isIE && Ext.isIE11) {
	Ext.isIE = true;
}

Ext.override(Ext.form.Field, {
	/**
	 * Reset field after file upload
	 * by raw resetting of form and resetting the field
	 */
	resetOnUpload: function () {
		var form = this.el.parent('form');
		if (null != form) {
			form.dom.reset();
		}
		this.reset();
	}
});

/**
 * Themed checkboxes/radios for Ext 3.0
 * http://www.extjs.com/forum/showthread.php?64689-Themed-checkboxes-radios-for-Ext-3.0
 */
Ext.override(Ext.form.Checkbox, {
	innerCls: 'x-form-checkbox-inner',
	onResize: function () {
		Ext.form.Checkbox.superclass.onResize.apply(this, arguments);
		if (!this.boxLabel) {
			this.innerWrap.alignTo(this.wrap, 'c-c');
		}
	},
	initEvents: function () {
		Ext.form.Checkbox.superclass.initEvents.call(this);
		this.mon(this.el, {
			click: this.onClick,
			change: this.onClick,
			mouseenter: this.onMouseEnter,
			mouseleave: this.onMouseLeave,
			mousedown: this.onMouseDown,
			mouseup: this.onMouseUp,
			scope: this
		});
	},
	onRender: function (ct, position) {
		Ext.form.Checkbox.superclass.onRender.call(this, ct, position);
		if (this.inputValue !== undefined) {
			this.el.dom.value = this.inputValue;
		}
		this.innerWrap = this.el.wrap({
			tag: 'span',
			cls: this.innerCls
		});
		this.wrap = this.innerWrap.wrap({
			cls: 'x-form-check-wrap'
		});
		if (this.boxLabel) {
			this.labelEl = this.wrap.createChild({
				tag: 'label',
				htmlFor: this.el.id,
				cls: 'x-form-cb-label',
				html: this.boxLabel
			});
		} else {
			this.innerWrap.addClass('x-form-check-no-label');
		}
		if (this.checked) {
			this.setValue(true);
		} else {
			this.checked = this.el.dom.checked;
		}
		// Need to repaint for IE, otherwise positioning is broken
		if (Ext.isIE) {
			this.wrap.repaint();
		}

		this.resizeEl = this.positionEl = this.wrap;
	},
	initValue: function () {
		this.originalValue = this.getValue();
	},
	onClick: function () {
		if (Ext.isSafari) {
			this.focus();
		}
		if (this.el.dom.checked != this.checked) {
			this.setValue(this.el.dom.checked);
		}
	},
	setRawValue: function (v) {
		this.setValue(v, false);
	},
	setValue: function (v, isFireEvent) {
		if (undefined === isFireEvent) {
			isFireEvent = true;
		}
		var checked = this.checked;
		this.checked = (v === true || v === 'true' || v == '1' || String(v).toLowerCase() == 'on');
		if (this.rendered) {
			this.el.dom.checked = this.checked;
			this.el.dom.defaultChecked = this.checked;
			this.innerWrap[this.checked ? 'addClass' : 'removeClass']('x-form-check-checked');
			this.wrap[this.checked ? 'addClass' : 'removeClass']('x-form-check-wrap-checked');
			this.validate();
		}
		if (checked != this.checked) {
			if (isFireEvent) {
				this.fireEvent('check', this, this.checked);
				if (this.handler) {
					this.handler.call(this.scope || this, this, this.checked);
				}
			}
		}
		return this;
	},
	onMouseEnter: function () {
		this.wrap.addClass('x-form-check-over');
	},
	onMouseLeave: function () {
		this.wrap.removeClass('x-form-check-over');
		this.wrap.removeClass('x-form-check-down');
	},
	onMouseDown: function () {
		this.wrap.addClass('x-form-check-down');
	},
	onMouseUp: function () {
		this.wrap.removeClass('x-form-check-down');
	},
	onFocus: function () {
		Ext.form.Checkbox.superclass.onFocus.call(this);
		this.wrap.addClass('x-form-check-focus');
	},
	onBlur: function () {
		Ext.form.Checkbox.superclass.onBlur.call(this);
		this.wrap.removeClass('x-form-check-focus');
	}
});
Ext.override(Ext.Button, {
	getPressed: function () {
		return this.pressed;
	}
});
Ext.override(Ext.form.Radio, {
	innerCls: 'x-form-radio-inner',
	onClick: Ext.form.Radio.superclass.onClick,
	setValue: function (v) {
		Ext.form.Radio.superclass.setValue.call(this, v);
		if (this.rendered && this.checked) {
			var p = this.el.up('form') || Ext.getBody(),
				els = p.select('input[name=' + this.el.dom.name + '][type=radio]'),
				id = this.el.dom.id;
			els.each(function (el) {
				if (el.dom.id != id) {
					Ext.getCmp(el.dom.id).setValue(false);
				}
			});
		}
		return this;
	}
});

Ext.override(Ext.Element, {
	/**
	 * At dragndrop time we not need hover reaction
	 */
	hover: function (overFn, outFn, scope, options) {
		var newOverFn = function () {
			if (Sb.Editor && !Sb.Editor.Ui.isDragActive()) {
				overFn.createDelegate(this, arguments)();
			}
		};
		var newOutFn = function () {
			if (Sb.Editor && !Sb.Editor.Ui.isDragActive()) {
				outFn.createDelegate(this, arguments)();
			}
		};
		var me = this;
		me.on('mouseenter', newOverFn, scope || me.dom, options);
		me.on('mouseleave', newOutFn, scope || me.dom, options);
		return me;
	},

	/**
	 * Tries to fit text in one line and truncates it if needed.
	 * If text truncates, then ellipsis is added at the end.
	 * Tags from innerHTML are truncated!
	 */
	ellipsize: function () {
		var endWith = '...';
		this.dom.innerHTML = Ext.util.Format.stripTags(this.dom.innerHTML);
		var currentText = this.dom.innerHTML;
		var currentHeight = this.getHeight();
		this.dom.innerHTML = endWith;
		var neededHeight = this.getHeight();
		this.dom.innerHTML = currentText;
		if (currentHeight <= neededHeight) {
			return;
		}
		var text = this.dom.innerHTML;
		var textEndWith = text.substring(text.length - endWith.length, text.length);
		if (textEndWith != endWith) {
			this.dom.innerHTML += endWith;
		}
		while (this.getHeight() > neededHeight && this.dom.innerHTML.length > endWith.length) {
			text = this.dom.innerHTML;
			text = text.substring(0, text.length - 1 - endWith.length);
			text += endWith;
			this.dom.innerHTML = text;
		}
	}
});

/**
 * Restrict the maximum number of characters that can be entered into the field.
 */
Ext.override(Ext.form.TextField, {
	maxLength: 65535,
	onRender: function (ct, position) {
		Ext.form.TextField.superclass.onRender.call(this, ct, position);
		this.el.set({
			maxLength: this.maxLength
		});
	}
});
Ext.override(Ext.form.TextArea, {
	initEvents: function () {
		Ext.form.TextArea.superclass.initEvents.call(this);
		this.mon(this.el, 'keypress', function (e) {
			if (this.el.dom.value.length > this.maxLength - 1) {
				if (e.ctrlKey) {
					return;
				}
				var k = e.getKey();
				if (Ext.isGecko && (e.isNavKeyPress() || k == e.BACKSPACE || (k == e.DELETE && e.button == -1))) {
					return;
				}
				var cc = String.fromCharCode(e.getCharCode());
				if (!Ext.isGecko && e.isSpecialKey() && !cc) {
					return;
				}
				e.stopEvent();
			}
		}, this);
	}
});

/**
 * String improvements
 */
Ext.apply(String.prototype, {
	/**
	 * @param {Boolean} [isUpperFirst]
	 * @return {String}
	 */
	camelize: function (isUpperFirst) {
		var parts, len, camelized, i;

		parts = this.split(/[\-_]+/);
		len = parts.length;
		camelized = (isUpperFirst) ? parts[0].toUpperCaseFirst() : parts[0].toLowerCaseFirst();
		for (i = 1; i < len; i++) {
			camelized += parts[i].toUpperCaseFirst();
		}
		return camelized;
	},

	toUpperCaseFirst: function () {
		if (this.length) {
			return this.charAt(0).toUpperCase() + this.substring(1);
		}
		return this;
	},

	toLowerCaseFirst: function () {
		if (this.length) {
			return this.charAt(0).toLowerCase() + this.substring(1);
		}
		return this;
	}
});

Ext.apply(RegExp, {
	/**
	 * Add escape prototype feature to RegExp object
	 */
	escape: function (text){
		var sp;
		if (!arguments.callee.sRE) {
			sp = ['/','.','*','+','?','|','(',')','[',']','{','}','\\'];
			arguments.callee.sRE = new RegExp('(\\' + sp.join('|\\') + ')', 'g');
		}
		return text.replace(arguments.callee.sRE, '\\$1');
	}
});

/**
 * Promote our usual form`s defaults here
 */
Ext.override(Ext.layout.FormLayout, {
	labelSeparator	: ''
});

/**
 * Promote our usual combo`s defaults here
 */
Ext.override(Ext.form.ComboBox, {
	triggerAction	: 'all',
	shadow			: false,
	editable		: false
});

/**
 * Fix up qtips non-inclusive mechanism
 */
Ext.override(Ext.QuickTip, {
	/**
	 * Register tips on every rendered child node of passed node, as current target mechanism isn`t inclusive
	 * @param {Object} config The config object (not array)
	 */
	registerSelfAndChildren: function (config) {
		var target	= config.target;
		delete config.target;
		if (!target || Ext.isArray(target)) {
			return;
		}
		var cmp	= Ext.getCmp(target.id),
			tgs	= this.targets;
		if (cmp) {
			if (cmp.wrap) {
				tgs[Ext.id(cmp.wrap)] = config;
				cmp.wrap.select('*[id]').each(function (item) {
					tgs[Ext.id(item)] = config;
				});
			} else {
				tgs[Ext.id(cmp.el)] = config;
				cmp.el.select('*[id]').each(function (item) {
					tgs[Ext.id(item)] = config;
				});
			}
		} else {
			var domTarget = Ext.get(target);
			tgs[Ext.id(domTarget)] = config;
			domTarget.select('*[id]').each(function (item) {
				tgs[Ext.id(item)] = config;
			});
		}
	}
});

Ext.apply(Ext.QuickTips, {
	/**
	 * Register tips on every rendered child node of passed node, as current target mechanism isn`t inclusive
	 */
	registerSelfAndChildren: function () {
		var tip = this.getQuickTip();
		tip.registerSelfAndChildren.apply(tip, arguments);
	}
});

Ext.apply(Ext.util.Format, {
	/**
	 * Insert <wbr> before slashes
	 * @param {String} value The string value to format
	 * @return {String} String with <wbr>
	 */
	wbrBySlash: function (value) {
		return value.replace(/\//g, '<img src="' + Ext.BLANK_IMAGE_URL + '" alt="" width="0" height="0" />/');
	},

	/**
	 * Strips HTML and PHP tags from a string
	 * @author http://phpjs.org/functions/strip_tags:535
	 * @param {Mixed} input The text from which to strip tags
	 * @param {Mixed} allowed Allowed tags
	 * @return {String} The stripped text
	 */
	stripTags: function (input, allowed) {
		allowed = (((allowed || "") + "")
			.toLowerCase()
			.match(/<[a-z][a-z0-9]*>/g) || [])
			.join('');
			var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,
				commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
			return input.replace(commentsAndPhpTags, '').replace(tags, function ($0, $1){
				return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
		});
	},

	/**
	 * Converts the first character of a string to upper case
	 * @param {String} value The text to convert
	* @return {String} The converted text
	 */
	ucfirst: function (value) {
		return !value ? value : value.charAt(0).toUpperCase() + value.substr(1);
	}
});

/**
 * Custom Vtype for vtype: 'emailMulti'.
 * Used to validate comma separated email addresses.
 */
Ext.apply(Ext.form.VTypes, {
	email: function (v) {
		v = v.replace(/^\s*/, '').replace(/\s*$/, '');
		return (/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i).test(v);
	},
	emailMask: /./i,

	emailMulti: function (v) {
		var result = true;
		Ext.each(v.split(/,|;/), function (v) {
			if (!Ext.form.VTypes.email(v)) {
				result = false;
				return false;
			}
		});
		return result;
	},
	emailMultiMask: /./i
});

Ext.onReady(function () {
	/**
	 * Remove show and dragging from Ext JS message boxes
	 */
	var dlg = Ext.MessageBox.getDialog();
	dlg.header.removeClass('x-window-draggable');
	dlg.header.on('mousedown', function (e) {
		e.stopEvent();
	});
	dlg.on('show', function () {
		dlg.el.disableShadow();
	});

	/**
	 * Overrides of common locale keys in ExtJS, emulating lang files, but in more stable way.
	 */
	if(Ext.form.BasicForm){
		Ext.form.BasicForm.prototype.waitTitle = Sb.Locale.get('pleaseWait');
	}
	if(Ext.ux.uploader && Ext.ux.uploader.Manager){
		Ext.ux.uploader.Manager.prototype.waitTitle = Sb.Locale.get('pleaseWait');
	}
	Ext.form.VTypes.emailMultiText = Sb.Locale.get('validationEmailMultiText');

	// Fix bug in Gecko-based browsers after upgrade to ExtJS 3.4.1.1
	if (Ext.isGecko) {
		Ext.getBody().addClass('ext-gecko');
	}

	if (Ext.isIE11) {
		document.body.className = document.body.className.replace(/ext-\S+/g,'') + ' ext-ie ext-ie11';
	}
});

/**
 * Useful methods from Ext JS 4
 */
Ext.apply(Ext, {
	/**
	 * Execute a callback function in a particular scope. If no function is passed the call is ignored.
	 *
	 * For example, these lines are equivalent:
	 *
	 *     Ext.callback(myFunc, this, [arg1, arg2]);
	 *     Ext.isFunction(myFunc) && myFunc.apply(this, [arg1, arg2]);
	 *
	 * @param {Function} callback The callback to execute
	 * @param {Object} [scope] The scope to execute in
	 * @param {Array} [args] The arguments to pass to the function
	 * @param {Number} [delay] Pass a number to delay the call by a number of milliseconds.
	 */
	callback: function (callback, scope, args, delay) {
		if (Ext.isFunction(callback)) {
			args = args || [];
			scope = scope || window;
			if (delay) {
				Ext.defer(callback, delay, scope, args);
			} else {
				callback.apply(scope, args);
			}
		}
	},

	/**
	 * Clone simple variables including array, {}-like objects, DOM nodes and Date without keeping the old reference.
	 * A reference for the object itself is returned if it's not a direct decendant of Object.
	 *
	 * @param {Object} item The variable to clone
	 * @return {Object} clone
	 */
	clone: function (item) {
		var type,
			i,
			j,
			k,
			clone,
			key,
			toString = Object.prototype.toString,
			enumerables = ['hasOwnProperty', 'valueOf', 'isPrototypeOf', 'propertyIsEnumerable',
				'toLocaleString', 'toString', 'constructor'];

		if (item === null || item === undefined) {
			return item;
		}

		// DOM nodes
		// TODO proxy this to Ext.Element.clone to handle automatic id attribute changing
		// recursively
		if (item.nodeType && item.cloneNode) {
			return item.cloneNode(true);
		}

		type = toString.call(item);

		// Date
		if (type === '[object Date]') {
			return new Date(item.getTime());
		}

		// Array
		if (type === '[object Array]') {
			i = item.length;

			clone = [];

			while (i--) {
				clone[i] = Ext.clone(item[i]);
			}
		}
		// Object
		else if (type === '[object Object]' && item.constructor === Object) {
			clone = {};

			for (key in item) {
				clone[key] = Ext.clone(item[key]);
			}

			if (enumerables) {
				for (j = enumerables.length; j--;) {
					k = enumerables[j];
					if (item.hasOwnProperty(k)) {
						clone[k] = item[k];
					}
				}
			}
		}

		return clone || item;
	}
});

// It looks like a bug of getXType() in 3.4.1.1 for objects defined over Ext.define()
Ext.override(Ext.Component, {
	getXType: function () {
		return (this.self || this.constructor).xtype;
	}
});

// Fix for legacy browsers
Ext.applyIf(Array.prototype, {
	map: function (fun) {
		var len = this.length;
		if (typeof fun != 'function') {
			throw new TypeError();
		}
		var res = new Array(len);
		var thisp = arguments[1];
		for (var i = 0; i < len; i++) {
			if (i in this) {
				res[i] = fun.call(thisp, this[i], i, this);
			}
		}
		return res;
	},

	filter: function (fun /*, thisp*/) {
		var len = this.length;
		if (typeof fun != "function") {
			throw new TypeError();
		}

		var res = [];
		var thisp = arguments[1];
		for (var i = 0; i < len; i++) {
			if (i in this) {
				var val = this[i]; // in case fun mutates this
				if (fun.call(thisp, val, i, this)) {
					res.push(val);
				}
			}
		}
		return res;
	},

	isEqual: function (array) {
		// if the other array is a falsy value, return
		if (!array) {
			return false;
		}

		// compare lengths - can save a lot of time
		if (this.length != array.length) {
			return false;
		}

		for (var i = 0; i < this.length; i++) {
			// Check if we have nested arrays
			if (this[i] instanceof Array && array[i] instanceof Array) {
				// recurse into the nested arrays
				if (!this[i].isEqual(array[i])) {
					return false;
				}
			} else if (this[i] != array[i]) {
				// Warning - two different object instances will never be equal: {x:20} != {x:20}
				return false;
			}
		}
		return true;
	}
});

// http://www.sencha.com/forum/showthread.php?170863-setOpacity-doesn-t-work-for-IE9
Ext.override(Ext.Element, {
	setOpacity: function (opacity, animate) {
		var me = this,
			s = me.dom.style;

		if (!animate || !me.anim) {
			if (Ext.isIE9m && !Ext.isIE9) {
				var opac = opacity < 1 ? 'alpha(opacity=' + opacity * 100 + ')' : '',
					val = s.filter.replace(/alpha\(opacity=(.*)\)/i, '').replace(/^\s+|\s+$/g, '');

				s.zoom = 1;
				s.filter = val + (val.length > 0 ? ' ' : '') + opac;
			} else {
				s.opacity = opacity;
			}
		} else {
			me.anim({opacity: {to: opacity}}, me.preanim(arguments, 1), null, .35, 'easeIn');
		}
		return me;
	}
});

// Add IE10 compability
Ext.override(Ext.layout.ColumnLayout, {
	getLayoutTargetSize: function () {
		var target = this.container.getLayoutTarget(), ret;
		if (target) {
			ret = target.getViewSize();

			// IE in strict mode will return a width of 0 on the 1st pass of getViewSize.
			// Use getStyleSize to verify the 0 width, the adjustment pass will then work properly
			// with getViewSize
			if (Ext.isIE && Ext.isStrict && ret.width == 0){
				ret =  target.getStyleSize();
			}

			ret.width -= target.getPadding('lr');
			ret.height -= target.getPadding('tb');
		}
		return ret;
	}
});